package com.derschmale.away3d
{
	import away3d.containers.ObjectContainer3D;
	import away3d.controllers.HoverController;
	import away3d.entities.Entity;

	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;

	public class MouseHoverController
	{
		private var move:Boolean = false;
		private var lastPanAngle:Number;
		private var lastTiltAngle:Number;
		private var lastMouseX:Number;
		private var lastMouseY:Number;
		private var hoverController : HoverController;
		private var stage : Stage;
		private var targetDistance : Number = 170;

		public function MouseHoverController(stage : Stage, controllee : Entity, target : ObjectContainer3D = null)
		{
			hoverController = new HoverController(controllee, target, 180, 10, targetDistance, -90, 90);
			this.stage = stage;
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function onMouseWheel(event : MouseEvent) : void
		{
			targetDistance -= 5*event.delta;
			if (targetDistance < 100) targetDistance = 100;
		}

		public function update() : void
		{
			hoverController.distance = (hoverController.distance + targetDistance) * .5;
			if (move) {
				hoverController.panAngle = 0.3*(stage.mouseX - lastMouseX) + lastPanAngle;
				hoverController.tiltAngle = 0.3*(stage.mouseY - lastMouseY) + lastTiltAngle;
			}
		}

		/**
		 * Mouse down listener for navigation
		 */
		private function onMouseDown(event:MouseEvent):void
		{
			lastPanAngle = hoverController.panAngle;
			lastTiltAngle = hoverController.tiltAngle;
			lastMouseX = stage.mouseX;
			lastMouseY = stage.mouseY;
			move = true;
			stage.addEventListener(Event.MOUSE_LEAVE, onStageMouseLeave);
		}

		/**
		 * Mouse up listener for navigation
		 */
		private function onMouseUp(event:MouseEvent):void
		{
			move = false;
			stage.removeEventListener(Event.MOUSE_LEAVE, onStageMouseLeave);
		}

		/**
		 * Mouse stage leave listener for navigation
		 */
		private function onStageMouseLeave(event:Event):void
		{
			move = false;
			stage.removeEventListener(Event.MOUSE_LEAVE, onStageMouseLeave);
		}
	}
}
