package com.derschmale.away3d.materials.methods
{
	import away3d.arcane;
	import away3d.materials.compilation.ShaderRegisterCache;
	import away3d.materials.compilation.ShaderRegisterElement;
	import away3d.materials.methods.BasicNormalMethod;
	import away3d.materials.methods.MethodVO;
	import away3d.materials.methods.ShadingMethodBase;

	use namespace arcane;

	public class WorldNormalMethod extends BasicNormalMethod
	{
		public function WorldNormalMethod()
		{
			super();
		}


		override arcane function initVO(vo : MethodVO) : void
		{
			vo.needsUV = Boolean(normalMap);
		}

		override arcane function get tangentSpace() : Boolean
		{
			return false;
		}

		override public function copyFrom(method : ShadingMethodBase) : void
		{
			normalMap = BasicNormalMethod(method).normalMap;
		}

		override arcane function getFragmentCode(vo : MethodVO, regCache : ShaderRegisterCache, targetReg : ShaderRegisterElement) : String
		{
			_normalTextureRegister = regCache.getFreeTextureReg();
			vo.texturesIndex = _normalTextureRegister.index;
			return getTex2DSampleCode(vo,  targetReg, _normalTextureRegister, normalMap) +
					"sub " + targetReg + ".xyz, " + targetReg + ".xyz, " + "fc0.xxx\n" +
					"nrm " + targetReg + ".xyz, " + targetReg + ".xyz\n";
		}
	}
}
